diff --git a/src/director/doveadm-connection.c b/src/director/doveadm-connection.c
index 2d32c2081..8960909f0 100644
--- a/src/director/doveadm-connection.c
+++ b/src/director/doveadm-connection.c
@@ -1158,9 +1158,10 @@ static void doveadm_connections_continue_reset_cmds(void)
 	}
 }
 
-void doveadm_connections_ring_synced(void)
+void doveadm_connections_ring_synced(struct director *dir)
 {
-	while (doveadm_ring_sync_pending_connections != NULL) {
+	while (doveadm_ring_sync_pending_connections != NULL &&
+	       dir->ring_synced) {
 		struct doveadm_connection *conn =
 			doveadm_ring_sync_pending_connections;
 		doveadm_connection_ring_sync_callback_t *callback =
@@ -1172,5 +1173,6 @@ void doveadm_connections_ring_synced(void)
 		io_set_pending(conn->io);
 		callback(conn);
 	}
-	doveadm_connections_continue_reset_cmds();
+	if (dir->ring_synced)
+		doveadm_connections_continue_reset_cmds();
 }
diff --git a/src/director/doveadm-connection.h b/src/director/doveadm-connection.h
index 0b55d8561..04904b617 100644
--- a/src/director/doveadm-connection.h
+++ b/src/director/doveadm-connection.h
@@ -8,6 +8,6 @@ doveadm_connection_init(struct director *dir, int fd);
 void doveadm_connections_deinit(void);
 
 void doveadm_connections_kick_callback(struct director *dir);
-void doveadm_connections_ring_synced(void);
+void doveadm_connections_ring_synced(struct director *dir);
 
 #endif
diff --git a/src/director/main.c b/src/director/main.c
index 5c8561f7d..c47fef7ec 100644
--- a/src/director/main.c
+++ b/src/director/main.c
@@ -258,7 +258,7 @@ static void director_state_changed(struct director *dir)
 
 	if (dir->to_request != NULL && array_count(&new_requests) == 0)
 		timeout_remove(&dir->to_request);
-	doveadm_connections_ring_synced();
+	doveadm_connections_ring_synced(dir);
 }
 
 static void main_preinit(void)
